Index: issm/trunk/src/c/DataSet/DataSet.cpp
===================================================================
--- issm/trunk/src/c/DataSet/DataSet.cpp	(revision 464)
+++ issm/trunk/src/c/DataSet/DataSet.cpp	(revision 465)
@@ -900,5 +900,5 @@
 #undef __FUNCT__
 #define __FUNCT__ "DataSet::CreateKMatrix"
-void  DataSet::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  DataSet::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	vector<Object*>::iterator object;
@@ -911,10 +911,10 @@
 
 			element=(Element*)(*object);
-			element->CreateKMatrix(Kgg,inputs,analysis_type);
+			element->CreateKMatrix(Kgg,inputs,analysis_type,sub_analysis_type);
 		}
 		if(EnumIsLoad((*object)->Enum())){
 
 			load=(Load*)(*object);
-			load->CreateKMatrix(Kgg,inputs,analysis_type);
+			load->CreateKMatrix(Kgg,inputs,analysis_type,sub_analysis_type);
 		}
 	}
@@ -924,5 +924,5 @@
 #undef __FUNCT__
 #define __FUNCT__ "DataSet::CreatePVector"
-void  DataSet::CreatePVector(Vec pg,void* inputs,int analysis_type){
+void  DataSet::CreatePVector(Vec pg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	vector<Object*>::iterator object;
@@ -935,10 +935,10 @@
 
 			element=(Element*)(*object);
-			element->CreatePVector(pg,inputs,analysis_type);
+			element->CreatePVector(pg,inputs,analysis_type,sub_analysis_type);
 		}
 		if(EnumIsLoad((*object)->Enum())){
 
 			load=(Load*)(*object);
-			load->CreatePVector(pg,inputs,analysis_type);
+			load->CreatePVector(pg,inputs,analysis_type,sub_analysis_type);
 		}		
 	}
@@ -984,5 +984,5 @@
 #undef __FUNCT__
 #define __FUNCT__ "DataSet::PenaltyCreateKMatrix"
-void  DataSet::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type){
+void  DataSet::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type){
 
 	vector<Object*>::iterator object;
@@ -994,5 +994,5 @@
 
 			load=(Load*)(*object);
-			load->PenaltyCreateKMatrix(Kgg,inputs,kmax,analysis_type);
+			load->PenaltyCreateKMatrix(Kgg,inputs,kmax,analysis_type,sub_analysis_type);
 		}
 	}
@@ -1002,5 +1002,5 @@
 #undef __FUNCT__
 #define __FUNCT__ "DataSet::PenaltyCreatePVector"
-void  DataSet::PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type){
+void  DataSet::PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type){
 
 	vector<Object*>::iterator object;
@@ -1012,5 +1012,5 @@
 
 			load=(Load*)(*object);
-			load->PenaltyCreatePVector(pg,inputs,kmax,analysis_type);
+			load->PenaltyCreatePVector(pg,inputs,kmax,analysis_type,sub_analysis_type);
 		}		
 	}
@@ -1028,5 +1028,5 @@
 #undef __FUNCT__
 #define __FUNCT__ "RiftConstraints"
-void  DataSet::RiftConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type){
+void  DataSet::RiftConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type,int sub_analysis_type){
 	
 	throw ErrorException(__FUNCT__," not implemented yet!");
@@ -1045,5 +1045,5 @@
 #undef __FUNCT__
 #define __FUNCT__ "MeltingConstraints"
-void  DataSet::MeltingConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type){
+void  DataSet::MeltingConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type,int sub_analysis_type){
 
 	throw ErrorException(__FUNCT__," not implemented yet!");
@@ -1084,5 +1084,5 @@
 
 
-void  DataSet::Du(Vec du_g,double*  u_g,double* u_g_obs,void* inputs,int analysis_type){
+void  DataSet::Du(Vec du_g,double*  u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type){
 
 
@@ -1095,12 +1095,12 @@
 
 			element=(Element*)(*object);
-			element->Du(du_g,u_g,u_g_obs,inputs,analysis_type);
-		}
-	}
-
-
-}
-
-void  DataSet::Gradj(Vec grad_g,double*  u_g,double* lambda_g,void* inputs,int analysis_type,char* control_type){
+			element->Du(du_g,u_g,u_g_obs,inputs,analysis_type,sub_analysis_type);
+		}
+	}
+
+
+}
+
+void  DataSet::Gradj(Vec grad_g,double*  u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type,char* control_type){
 
 
@@ -1113,5 +1113,5 @@
 
 			element=(Element*)(*object);
-			element->Gradj(grad_g,u_g,lambda_g,inputs,analysis_type,control_type);
+			element->Gradj(grad_g,u_g,lambda_g,inputs,analysis_type,sub_analysis_type,control_type);
 		}
 	}
@@ -1120,5 +1120,5 @@
 }		
 		
-void  DataSet::Misfit(double* pJ, double* u_g,double* u_g_obs,void* inputs,int analysis_type){
+void  DataSet::Misfit(double* pJ, double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type){
 
 	double J=0;;
@@ -1132,5 +1132,5 @@
 
 			element=(Element*)(*object);
-			J+=element->Misfit(u_g,u_g_obs,inputs,analysis_type);
+			J+=element->Misfit(u_g,u_g_obs,inputs,analysis_type,sub_analysis_type);
 
 		}
Index: issm/trunk/src/c/DataSet/DataSet.h
===================================================================
--- issm/trunk/src/c/DataSet/DataSet.h	(revision 464)
+++ issm/trunk/src/c/DataSet/DataSet.h	(revision 465)
@@ -47,5 +47,5 @@
 		void  DistributeDofs(int numberofnodes,int numdofspernode);
 		void  CreatePartitioningVector(Vec* ppartition,int numnods,int numdofspernode);
-		void  DistributeNumDofs(int** pnumdofspernode,int numberofnodes,int analysis_type);
+		void  DistributeNumDofs(int** pnumdofspernode,int numberofnodes,int analysis_type,int sub_analysis_type);
 		void  FlagClones(int numberofnodes);
 		int   NumberOfDofs();
@@ -61,17 +61,17 @@
 		void  SetSorting(int* in_sorted_ids,int* in_id_offsets);
 		void  Sort();
-		void  CreateKMatrix(Mat Kgg,void* inputs, int analysis_type);
-		void  CreatePVector(Vec pg,void* inputs, int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs, int analysis_type,int sub_analysis_type);
+		void  CreatePVector(Vec pg,void* inputs, int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
-		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type);
-		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type);
+		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
+		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
 		int   RiftIsPresent();
-		void  RiftConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type);
+		void  RiftConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type,int sub_analysis_type);
 		int   MeltingIsPresent();
-		void  MeltingConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type);
+		void  MeltingConstraints(int* pnum_unstable_constraints,void* inputs,int analysis_type,int sub_analysis_type);
 		DataSet* Copy(void);
-		void  Du(Vec du_g,double*  u_g,double* u_g_obs,void* inputs,int analysis_type);
-		void  Gradj(Vec grad_g,double*  u_g,double* lambda_g,void* inputs,int analysis_type,char* control_type);
-		void  Misfit(double* pJ, double* u_g,double* u_g_obs,void* inputs,int analysis_type);
+		void  Du(Vec du_g,double*  u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type);
+		void  Gradj(Vec grad_g,double*  u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type,char* control_type);
+		void  Misfit(double* pJ, double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type);
 		void  VelocityExtrude(Vec ug,double* ug_serial);
 		void  SlopeExtrude(Vec sg,double* sg_serial);
Index: issm/trunk/src/c/Dux/Dux.cpp
===================================================================
--- issm/trunk/src/c/Dux/Dux.cpp	(revision 464)
+++ issm/trunk/src/c/Dux/Dux.cpp	(revision 465)
@@ -14,5 +14,5 @@
 
 void Dux( Vec* pdu_g, DataSet* elements,DataSet* nodes, DataSet* loads, DataSet* materials, 
-		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type){
+		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 	int i;
@@ -33,5 +33,5 @@
 
 	/*Compute velocity difference: */
-	elements->Du(du_g, u_g,u_g_obs,inputs,analysis_type);
+	elements->Du(du_g, u_g,u_g_obs,inputs,analysis_type,sub_analysis_type);
 
 	/*Assemble vector: */
Index: issm/trunk/src/c/Dux/Dux.h
===================================================================
--- issm/trunk/src/c/Dux/Dux.h	(revision 464)
+++ issm/trunk/src/c/Dux/Dux.h	(revision 465)
@@ -10,5 +10,5 @@
 /* local prototypes: */
 void Dux( Vec* pdu_g, DataSet* elements,DataSet* nodes, DataSet* loads, DataSet* materials, 
-		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type);
+		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type,int sub_analysis_type);
 
 #endif  /* _DUX_H */
Index: issm/trunk/src/c/EnumDefinitions/AnalysisTypeAsEnum.cpp
===================================================================
--- issm/trunk/src/c/EnumDefinitions/AnalysisTypeAsEnum.cpp	(revision 464)
+++ issm/trunk/src/c/EnumDefinitions/AnalysisTypeAsEnum.cpp	(revision 465)
@@ -15,47 +15,50 @@
 	}
 
-	if (strcmp(analysis_type,"control")==0){
+	if (strcmp(analysis_type,"diagnostic")==0){
+		return DiagnosticAnalysisEnum();
+	}
+	else if (strcmp(analysis_type,"control")==0){
 		return ControlAnalysisEnum();
 	}
-	else if (strcmp(analysis_type,"diagnostic_horiz")==0){
-		return DiagnosticHorizAnalysisEnum();
-	}
-	else if (strcmp(analysis_type,"diagnostic_vert")==0){
-		return DiagnosticVertAnalysisEnum();
+	else if (strcmp(analysis_type,"thermal")==0){
+		return ThermalAnalysisEnum();
 	}
 	else if (strcmp(analysis_type,"prognostic")==0){
 		return PrognosticAnalysisEnum();
 	}
-	else if (strcmp(analysis_type,"thermalsteady")==0){
-		return ThermalSteadyAnalysisEnum();
-	}
-	else if (strcmp(analysis_type,"thermaltransient")==0){
-		return ThermalTransientAnalysisEnum();
-	}
 	else if (strcmp(analysis_type,"melting")==0){
 		return MeltingAnalysisEnum();
-	}
-	else if (strcmp(analysis_type,"diagnostic_stokes")==0){
-		return DiagnosticStokesAnalysisEnum();
-	}
-	else if (strcmp(analysis_type,"diagnostic_hutter")==0){
-		return DiagnosticHutterAnalysisEnum();
 	}
 	else if (strcmp(analysis_type,"slope_compute")==0){
 		return SlopeComputeAnalysisEnum();
 	}
-	else if (strcmp(analysis_type,"surface_slope_compute_x")==0){
-		return SurfaceSlopeComputeXAnalysisEnum();
+	else if (strcmp(analysis_type,"stokes")==0){
+		return StokesAnalysisEnum();
 	}
-	else if (strcmp(analysis_type,"surface_slope_compute_y")==0){
-		return SurfaceSlopeComputeYAnalysisEnum();
+	else if (strcmp(analysis_type,"hutter")==0){
+		return HutterAnalysisEnum();
 	}
-	else if (strcmp(analysis_type,"bed_slope_compute_x")==0){
-		return BedSlopeComputeXAnalysisEnum();
+	else if (strcmp(analysis_type,"surfacex")==0){
+		return SurfaceXAnalysisEnum();
 	}
-	else if (strcmp(analysis_type,"bed_slope_compute_y")==0){
-		return BedSlopeComputeYAnalysisEnum();
+	else if (strcmp(analysis_type,"surfacey")==0){
+		return SurfaceYAnalysisEnum();
 	}
-	else throw ErrorException(__FUNCT__," could not recognized analysis type!");
+	else if (strcmp(analysis_type,"bedx")==0){
+		return BedXAnalysisEnum();
+	}
+	else if (strcmp(analysis_type,"bedy")==0){
+		return BedYAnalysisEnum();
+	}
+	else if (strcmp(analysis_type,"horiz")==0){
+		return HorizAnalysisEnum();
+	}
+	else if (strcmp(analysis_type,"vert")==0){
+		return VertAnalysisEnum();
+	}
+	else if (strcmp(analysis_type,"")==0){
+		return NoneAnalysisEnum();
+	}
+	else throw ErrorException(__FUNCT__,exprintf("%s%s"," could not recognize analysis type: ",analysis_type));
 
 }
Index: issm/trunk/src/c/EnumDefinitions/EnumDefinitions.cpp
===================================================================
--- issm/trunk/src/c/EnumDefinitions/EnumDefinitions.cpp	(revision 464)
+++ issm/trunk/src/c/EnumDefinitions/EnumDefinitions.cpp	(revision 465)
@@ -15,20 +15,19 @@
 
 /*analysis types: */
-int StructuralAnalysisEnum(void){       return          20; }
-int ThermalAnalysisEnum(void){          return          21; }
-int ControlAnalysisEnum(void){          return          22; }
-int DiagnosticHorizAnalysisEnum(void){  return          23; }
-int DiagnosticVertAnalysisEnum(void){   return          24; }
-int PrognosticAnalysisEnum(void){       return          26; }
-int ThermalSteadyAnalysisEnum(void)	{   return          27; }
-int ThermalTransientAnalysisEnum(void){ return          28; }
-int MeltingAnalysisEnum(void){          return          29; }
-int DiagnosticStokesAnalysisEnum(void){ return          30; }
-int DiagnosticHutterAnalysisEnum(void){ return          31; }
-int SlopeComputeAnalysisEnum(void){ return              32; }
-int SurfaceSlopeComputeXAnalysisEnum(void){ return      33; }
-int SurfaceSlopeComputeYAnalysisEnum(void){ return      34; }
-int BedSlopeComputeXAnalysisEnum(void){ return          35; }
-int BedSlopeComputeYAnalysisEnum(void){ return          36; }
+int DiagnosticAnalysisEnum(void){  return               20; }
+int ControlAnalysisEnum(void){          return          21; }
+int ThermalAnalysisEnum(void){          return          22; }
+int PrognosticAnalysisEnum(void){          return       23; }
+int MeltingAnalysisEnum(void){          return          24; }
+int SlopeComputeAnalysisEnum(void){ return              25; }
+int StokesAnalysisEnum(void){ return                    26; }
+int HutterAnalysisEnum(void){ return                    27; }
+int SurfaceXAnalysisEnum(void){ return                  28; }
+int SurfaceYAnalysisEnum(void){ return                  29; }
+int BedXAnalysisEnum(void){ return                      30; }
+int BedYAnalysisEnum(void){ return                      31; }
+int HorizAnalysisEnum(void){ return                     32; }
+int VertAnalysisEnum(void){ return                      33; }
+int NoneAnalysisEnum(void){ return                      34; }
 
 /*datasets: */
Index: issm/trunk/src/c/EnumDefinitions/EnumDefinitions.h
===================================================================
--- issm/trunk/src/c/EnumDefinitions/EnumDefinitions.h	(revision 464)
+++ issm/trunk/src/c/EnumDefinitions/EnumDefinitions.h	(revision 465)
@@ -34,18 +34,19 @@
 
 /* analysis enums: */
+int DiagnosticAnalysisEnum(void);
 int ControlAnalysisEnum(void);
-int DiagnosticHorizAnalysisEnum(void);
-int DiagnosticVertAnalysisEnum(void);
+int ThermalAnalysisEnum(void);
 int PrognosticAnalysisEnum(void);
-int ThermalSteadyAnalysisEnum(void);
-int ThermalTransientAnalysisEnum(void);
 int MeltingAnalysisEnum(void);
-int DiagnosticStokesAnalysisEnum(void);
-int DiagnosticHutterAnalysisEnum(void);
 int SlopeComputeAnalysisEnum(void);
-int SurfaceSlopeComputeXAnalysisEnum(void);
-int SurfaceSlopeComputeYAnalysisEnum(void);
-int BedSlopeComputeXAnalysisEnum(void);
-int BedSlopeComputeYAnalysisEnum(void);
+int StokesAnalysisEnum(void);
+int HutterAnalysisEnum(void);
+int SurfaceXAnalysisEnum(void);
+int SurfaceYAnalysisEnum(void);
+int BedXAnalysisEnum(void);
+int BedYAnalysisEnum(void);
+int HorizAnalysisEnum(void);
+int VertAnalysisEnum(void);
+int NoneAnalysisEnum(void);
 
 
Index: issm/trunk/src/c/Gradjx/Gradjx.cpp
===================================================================
--- issm/trunk/src/c/Gradjx/Gradjx.cpp	(revision 464)
+++ issm/trunk/src/c/Gradjx/Gradjx.cpp	(revision 465)
@@ -14,5 +14,5 @@
 
 void Gradjx( Vec* pgrad_g, DataSet* elements,DataSet* nodes, DataSet* loads, DataSet* materials, 
-		double* u_g, double* lambda_g, ParameterInputs* inputs,int analysis_type,char* control_type){
+		double* u_g, double* lambda_g, ParameterInputs* inputs,int analysis_type,int sub_analysis_type,char* control_type){
 
 	int i;
@@ -33,5 +33,5 @@
 
 	/*Compute gradients: */
-	elements->Gradj(grad_g, u_g,lambda_g,inputs,analysis_type,control_type);
+	elements->Gradj(grad_g, u_g,lambda_g,inputs,analysis_type,sub_analysis_type,control_type);
 
 	/*Assemble vector: */
Index: issm/trunk/src/c/Gradjx/Gradjx.h
===================================================================
--- issm/trunk/src/c/Gradjx/Gradjx.h	(revision 464)
+++ issm/trunk/src/c/Gradjx/Gradjx.h	(revision 465)
@@ -10,5 +10,5 @@
 /* local prototypes: */
 void Gradjx( Vec* pgrad_g, DataSet* elements,DataSet* nodes, DataSet* loads, DataSet* materials, 
-		double* u_g, double* lambda_g, ParameterInputs* inputs,int analysis_type,char* control_type);
+		double* u_g, double* lambda_g, ParameterInputs* inputs,int analysis_type,int sub_analysis_type,char* control_type);
 
 #endif  /* _GRADJX_H */
